searchData={"items":[{"type":"module","title":"Terrasol","doc":"Various utility functions to assist with some of the\nunique requirements for Earthstar documents.","ref":"Terrasol.html"},{"type":"function","title":"Terrasol.bdecode/1","doc":"Decode the Base32 standard for Earthstar","ref":"Terrasol.html#bdecode/1"},{"type":"function","title":"Examples - Terrasol.bdecode/1","doc":"iex> Terrasol.bdecode(\"b6cp2jipqt6jks\")\n    \"🤡💩\"\n\n    iex> Terrasol.bdecode(\"bmfrggzdfmy\")\n    \"abcdef\"\n\n    iex> Terrasol.bdecode(\"mfrggzdfmy\")\n    :error","ref":"Terrasol.html#bdecode/1-examples"},{"type":"function","title":"Terrasol.bencode/1","doc":"Encode the Base32 standard for Earthstar","ref":"Terrasol.html#bencode/1"},{"type":"function","title":"Examples - Terrasol.bencode/1","doc":"iex> Terrasol.bencode(\"🤡💩\")\n    \"b6cp2jipqt6jks\"\n\n    iex> Terrasol.bencode(\"abcdef\")\n    \"bmfrggzdfmy\"","ref":"Terrasol.html#bencode/1-examples"},{"type":"function","title":"Terrasol.duration_us/1","doc":"Convert a duration into a number of microseconds.\n\nInteger durations are taken as a number of seconds.\n\nKeyword lists are interpreted for the implemented durations.\nUnimplemented items are treated as 0\n\n:weeks, :days, :hours, :minutes\n:seconds, :milliseconds, :microseconds","ref":"Terrasol.html#duration_us/1"},{"type":"function","title":"Examples - Terrasol.duration_us/1","doc":"iex> Terrasol.duration_us(600)\n      600000000\n\n      iex> Terrasol.duration_us(minutes: 10, microseconds: 321)\n      600000321\n\n      iex> Terrasol.duration_us(\"600s\")\n      0","ref":"Terrasol.html#duration_us/1-examples"},{"type":"module","title":"Terrasol.Author","doc":"Handling of Earthstar author strings and resulting \nTerrasol.Author.t structures","ref":"Terrasol.Author.html"},{"type":"function","title":"Terrasol.Author.build/1","doc":"Fill a `Terrasol.Author` structure from an address string or\n(possibly incomplete) map.\n\nInternal conflict resolution is determinisitic, but depends on\nimplementation-specific ordering which is not gauranteed and should\nnot be depended upon being the same between versions.\n\n`:error` on invalid input","ref":"Terrasol.Author.html#build/1"},{"type":"function","title":"Terrasol.Author.from_keypair_file/1","doc":"Create a `Terrasol.Author` structure from a `keypair.json`-style file\n\n`:error` on error","ref":"Terrasol.Author.html#from_keypair_file/1"},{"type":"function","title":"Terrasol.Author.parse/1","doc":"Parse an author address into a `Terrasol.Author`\n\n`:error` on invalid input","ref":"Terrasol.Author.html#parse/1"},{"type":"type","title":"Terrasol.Author.t/0","doc":"An Earthstar author","ref":"Terrasol.Author.html#t:t/0"},{"type":"function","title":"Terrasol.Author.to_keypair_file/2","doc":"Write a `keypair.json`-style file from a supplied identity.\nAs a secret file, the `publickey` must be included.","ref":"Terrasol.Author.html#to_keypair_file/2"},{"type":"module","title":"Terrasol.Document","doc":"Generic document handling\n\nOne may add additional handlers which conform to the \n`Terrasol.Document.Format` behaviour. These are controlled by\n`Config` parameters.  The default values are equivalent to:\n\n```\nconfig :terrasol,\n  load_default_format_mods: true,\n  format_mods: []\n```","ref":"Terrasol.Document.html"},{"type":"function","title":"Terrasol.Document.build/1","doc":"Build a Terrasol.Document from a supplied map applying appropriate defaults\n\nDefaults to \"es.4\" format.\n\nReturns `:error` on an unparseable map. tuple if a `Terrasol.Document.Format` handler returns same.\nReturns an :invalid tuple if a `Terrasol.Document.Format` handler returns same.","ref":"Terrasol.Document.html#build/1"},{"type":"function","title":"Terrasol.Document.parse/1","doc":"Parse a map into a Terrasol.Document struct\n\nThis consists of:\n\n`format`: the selected module\n`content`: an appropriate struct\n\nStrings are considered to be JSON maps and decoded before use.\n\nReturns `:error` on an unparseable map. tuple if a `Terrasol.Document.Format` handler returns same.\nReturns an :invalid tuple if a `Terrasol.Document.Format` handler returns same.","ref":"Terrasol.Document.html#parse/1"},{"type":"module","title":"Terrasol.Document.ES4","doc":"Handling of the Earthstar \"es.4\" document format and the resulting\nstructures","ref":"Terrasol.Document.ES4.html"},{"type":"function","title":"Terrasol.Document.ES4.build/1","doc":"Build a `Terrasol.Document.ES4` from a map containing all or some of the required keys.\n\nThis is resolved internally in a deterministic way which is implementation-specific\nand should not be depended upon to remain the same between versions.\n\nA `:ttl` key may be used. It will be parsed into a `:deleteAfter` using \nthe document timestamp and adding `Terrasol.duration_us(ttl)`\n\nThe final value is passed through `parse/1` returning as that function does.","ref":"Terrasol.Document.ES4.html#build/1"},{"type":"function","title":"Terrasol.Document.ES4.parse/1","doc":"Parse and return a `Terrasol.Document.ES4` from a map.\n\nReturns `{:invalid, [error_field]}` on an invalid document","ref":"Terrasol.Document.ES4.html#parse/1"},{"type":"behaviour","title":"Terrasol.Document.Format","doc":"Behaviour for Document handler modules","ref":"Terrasol.Document.Format.html"},{"type":"callback","title":"Terrasol.Document.Format.build/1","doc":"Build a struct from a supplied map using proper defaults\n\nReturn {:invalid, [atoms for invalid supplied keys]}","ref":"Terrasol.Document.Format.html#c:build/1"},{"type":"callback","title":"Terrasol.Document.Format.format_string/0","doc":"The \"format\" value which this module handles","ref":"Terrasol.Document.Format.html#c:format_string/0"},{"type":"callback","title":"Terrasol.Document.Format.parse/1","doc":"Parse a map into a struct.\n\nReturn {:invalid, [atoms for unvalidatable keys]}","ref":"Terrasol.Document.Format.html#c:parse/1"},{"type":"module","title":"Terrasol.Path","doc":"Handling of Earthstar path strings and the resulting\n`Terrasol.Path.t` structures","ref":"Terrasol.Path.html"},{"type":"function","title":"Terrasol.Path.parse/1","doc":"Parse an Earthstar path string into a `Terrasol.Path`\n\n`:error` on invalid input","ref":"Terrasol.Path.html#parse/1"},{"type":"type","title":"Terrasol.Path.t/0","doc":"An Earthstar path","ref":"Terrasol.Path.html#t:t/0"},{"type":"module","title":"Terrasol.Workspace","doc":"Handling of Earthstar workspace strings and resulting \n`Terrasol.Workspace.t` structures","ref":"Terrasol.Workspace.html"},{"type":"function","title":"Terrasol.Workspace.parse/1","doc":"Parse an Earthstar workspace address into a `Terrasol.Workspace`.\n\n`:error` on invalid input","ref":"Terrasol.Workspace.html#parse/1"},{"type":"type","title":"Terrasol.Workspace.t/0","doc":"An Earthstar workspace","ref":"Terrasol.Workspace.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}